﻿@addTagHelper *, Microsoft.AspNetCore.Mvc.TagHelpers
@using DataTables.AspNetCore.Mvc
@model CyberaniumModels.ClientEnablers
@{
    ViewData["Title"] = "Index";
}
@if (!string.IsNullOrEmpty(TempData["success"]?.ToString()))
{
    <script>
        toastr.success('@TempData["success"]');
    </script>
}
else if (!string.IsNullOrEmpty(TempData["error"]?.ToString()))
{
    <script>
        toastr.error('@TempData["error"]');
    </script>
}

<style>
    .btn-info {
        color: #fff;
        background-color: #085c5b;
        border-color: #46b8da;
    }
</style>
<script src="~/Script/Master/Layout.js"></script>

<section>

    <div class="right_section">
        <div class="titile_heading" id="title_List">
            <h1>Enabler</h1>
            <div class="titile_line"></div>
        </div>
        <div class="col-lg-12 col-md-12 col-sm-12 col-xs-12">
            <div class="right_panel">
                <div class="right_content">
                    <div class="service_line">
                        @*data-ajax-success="fn_Onsuccess(data,'ApplicationManagement/ClientEnabler/Index');"*@
                        @*asp-action="SubmitClientEnabler" asp-controller="ClientEnabler" asp-area="ApplicationManagement"*@
                        <form data-ajax="true" id="form" asp-action="SubmitClientEnabler" asp-controller="ClientEnabler"
                              data-ajax-method="POST"
                              data-ajax-mode="replace"
                              data-loading-text="loading......"
                              data-ajax-update="#ajaxresult"
                              data-ajax-success="fn_Onsuccess(data,'ApplicationManagement/ClientEnabler/Index');"
                              data-ajax-failure="Errmsg(data);" method="post">
                                @Html.HiddenFor(m => m.ParentOrgId)
                                @Html.HiddenFor(m => m.ChildOrgId)
                                @Html.HiddenFor(m => m.QuestionnaireXML)
                            <div class="pb-2 mt-4 mb-2 border-bottom box_title">
                                Client Enablers Mapping
                            </div>
                            @*<div class="row">
                                    <div class="col-12 text-center">
                                        <label>Select Organization Type</label>
                                        <div class="select_box m_bottom">
                                            <label class="col-6 text-right pr-2">
                                                <input type="radio" name="Organization" value="0" onclick="ManageOrganizationDiv(this)" checked>  Organization
                                            </label>
                                            <label class="col-6 text-left pl-2">
                                                <input type="radio" name="Organization" value="1" onclick="ManageOrganizationDiv(this)">  Child Organization
                                            </label>
                                        </div>
                                    </div>
                                </div>
                                <div class="mb-2 border-bottom box_title"></div>*@
                            <div class="row">
                                @*<div class="col-md-4 col-sm-6 col-xs-12" style="display:none" id="divChildOrg">
                                        <label>Child Company</label>
                                        <div class="select_box m_bottom">
                                            @Html.DropDownListFor(m => m.ChildOrgId, Model.DdlOrganizations, "Select", new { @class = "form-control m_no" })
                                        </div>
                                    </div>
                                    <script>
                                        function ManageOrganizationDiv(checkbox) {
                                            var val = parseInt($(checkbox).val());
                                            if (val > 0) {
                                                $('#divChildOrg').show();
                                                $('#ChildOrgId').find('option:eq(0)').prop('selected', true);
                                            } else {
                                                $('#divChildOrg').hide();
                                                $('#ChildOrgId').find('option:eq(0)').prop('selected', true);
                                            }
                                        }
                                    </script>*@
                                <div class="col-md-4 col-sm-6 col-xs-12">
                                    <label>Category</label>
                                    <div class="select_box m_bottom">
                                        @Html.DropDownListFor(m => m.CategoryId, Model.DdlControlCat, new { @class = "form-control m_no multiple chosen-select", @multiple = "multiple", @style = "min-height:100px;" })
                                    </div>
                                </div>
                                <div class="col-1 pt-5">
                                    <input type="button" class="btn btn-info" value="view" onclick="fn_GetAssesmentClient(this)" />
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-12">
                                    <div class="table_control" id="dvmultiTable">
                                    </div>
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-md-12 col-sm-12 col-xs-12">
                                    <div class="back_btn mt5" id="viewbutton">
                                        <div class="back_btn_in" data-title="Back">
                                            <input type="button" name="Back" onclick="BackButton()" value="Back">
                                        </div>
                                    </div>
                                    <div class="submitbtn mt5">
                                        <input type="submit" id="btnsubmit" name="Submit" value="Submit" onclick="SaveQuestionnaire()">
                                    </div>
                                </div>
                            </div>
                        </form>
                    </div>
                    <div class="assign_panel assign_section" id="dvDataTable">
                        <div class="assign_box active_block fade in">
                            <div class="row">
                                <div class="col-12 text-center">
                                    <label>Select Organization Type</label>
                                    <div class="select_box m_bottom">
                                        <label class="radio-inline">
                                            <input type="radio" name="radio" value="1" onclick="UpdateTableList(this)" checked>Parent Organization
                                        </label>
                                        <label class="radio-inline">
                                            <input type="radio" name="radio" value="0" onclick="UpdateTableList(this)">Child Organization
                                        </label>
                                    </div>
                                </div>
                            </div>
                            <script>
                                function UpdateTableList(radio) {
                                    var val = parseInt($(radio).val());
                                    if (val > 0) {
                                        $.get('/ApplicationManagement/ClientEnabler/Index', { isParent: true }, function (data) {
                                            $('#ajaxresult').html(data);
                                            $('[name="radio"]').eq(0).prop('checked', true);
                                        })
                                    } else {
                                        $.get('/ApplicationManagement/ClientEnabler/Index', { isParent: false }, function (data) {
                                            $('#ajaxresult').html(data);
                                            $('[name="radio"]').eq(1).prop('checked', true);
                                        })
                                    }
                                }
                            </script>
                            <div class="mb-2 border-bottom box_title"></div>
                            <div class="row">
                                <div class="table_control">
                                    <table id="example2" class="table table-bordered table-hover">
                                        <thead>
                                            <tr>
                                                <th style="width:70px">SN</th>
                                                <th>Organization Name</th>
                                                <th>Office Location</th>
                                                <th style="width:130px">Action</th>
                                            </tr>
                                        </thead>
                                        <tbody>
                                            @{int sn = 0;}
                                            @foreach (var item in Model.OrganizationsList)
                                            {
                                                <tr>
                                                    <td>@(++sn)</td>
                                                    <td>@item.ParentOrgName</td>
                                                    <td>@item.CorporateOfficeLocation</td>
                                                    <td>
                                                        <a data-ajax="true" data-ajax-method="GET" data-ajax-mode="replace" data-ajax-update="#ajaxresult" asp-action="Index" asp-route-parentOrgId="@(item.OrganizationId>0?item.OrganizationId:item.Id)" asp-route-childOrgId="@item.OrganizationId" asp-controller="ClientEnabler" asp-area="ApplicationManagement" class="edit_btn"></a>
                                                        @*<a data-ajax="true" data-ajax-method="GET" data-ajax-mode="replace" data-ajax-update="#ajaxresult" asp-action="BlockDeleteOrganization" asp-route-Id="@item.Id" asp-route-Type="0" asp-controller="Organization" asp-area="ApplicationManagement" class="Active_btn" asp-route-ActionName="@(item.IsActive ? "InActive" : "Active")"></a>*@
                                                        @*<a class="delete_btn" onclick="Confirmation('@item.Id')"></a>*@
                                                    </td>
                                                </tr>
                                            }
                                        </tbody>
                                    </table>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</section>
<div id="visiblehide" style="display:none;"></div>

<script type="text/javascript">
    $(document).ready(function () {
        $("#btnsubmit").show();
        if ($("#ParentOrgId").val() > 0) {
            $(".titile_heading h1").html("Add Enabler");
            $(".service_line").addClass("active");
            $(".assign_panel").hide();
            $(".titile_heading").show();
        } else {
            $(".titile_heading h1").html("Enabler");
            $(".service_line").removeClass("active");
            $(".assign_panel").show();
            $(".titile_heading").show();
        }
    });
    function fn_GetQuestionnaire(select) {
        debugger;
        $('#preloader').show();
        $("#dvmultiTable").empty();
        $('#CategoryId option:selected').each(function (i) {
            var CategoryId = $(this).val();
            var CategoryText = $(this).text();
            if (CategoryId == 'multiselect-all') {
                $("#dvmultiTable").empty();
                return;
            }
            var html = '<table class="table" id="tbl_' + CategoryId + '"><thead><tr>';
            $.get('/ApplicationManagement/Compliance/GetQuestionnaireById', { CategoryId: CategoryId }, function (data) {
                html += '<th colspan="' + parseInt(data.length + 2) + '">' + CategoryText + '</th></tr>';
                html += '<tr><th name="0">SN</th>';
                $.each(data, function (i, value) {
                    html += '<th name=' + value.id + '>' + value.query + '</th>';
                });
                html += '<th name="0">Action</th></tr></thead><tbody><tr><td>1</td>';
                $.each(data, function (i, value) {
                    html += '<td><input type="hidden" class="form-control ques" value="' + value.id + '" /><input type="text" class="form-control ques' + value.id + '" /></td>';
                });
                html += '<td><input type="button" class="btn btn-info" value="+" onclick="AddMoreAnswers(this)"/></td></tr></tbody></table>';
                $("#dvmultiTable").append(html);
                $('#preloader').hide();
            });
        });
    }
    function fn_GetAssesmentClient(input) {
        $("#que").removeClass("hidden");
        $("#dvmultiTable").empty();
        var parentOrgId = $('#ParentOrgId').val();
        var childOrgId = $('#ChildOrgId').val() == '' ? 0 : $('#ChildOrgId').val();
        // var CategoryID = $(input).val();
        $('#CategoryId option:selected').each(function (i) {
            var CategoryId = $(this).val();
            var CategoryText = $(this).text();
            if (CategoryId == 'multiselect-all') {
                //$("#dvmultiTable").empty();
                return;
            }
            var html = '<table class="table" id="tbl_' + CategoryId + '"><thead><tr>';
            $.get('/ApplicationManagement/EnablerAssessment/GetAssesmentClient', { parentOrgId: parentOrgId, childOrgId: childOrgId, categoryId: CategoryId }, function (data) {
                debugger;
                console.log(data);
                var getEnablerQuestion = data.getEnablerQuestion;
                var GetQuestion = data.getQuestion;
                if (getEnablerQuestion.length == 0) {
                    debugger;
                    html += '<th colspan="' + parseInt(GetQuestion.length + 2) + '">' + CategoryText + '</th></tr>';
                    html += '<tr><th name="0">SN</th>';
                    $.each(GetQuestion, function (i, value) {
                        html += '<th name=' + value.id + '>' + value.query + '</th>';
                    });
                    html += '<th name="0">Action <input type="button" class="btn btn-info pull-right" value="+" onclick="AddMoreAnswers(this)"/></th></tr></thead><tbody><tr><td>1</td>';
                    $.each(GetQuestion, function (i, value) {
                        html += '<td><input type="hidden" class="form-control ques" value="' + value.id + '" /><input type="text" class="form-control ques' + value.id + '" /></td>';
                    });
                    html += '<td><input type="button" class="btn btn-danger" value="-" onclick="RemoveMoreAnswers(this)"></td></tr></tbody></table>';
                    $("#dvmultiTable").append(html);
                    $('#preloader').hide();
                } else {
                    html += '<th  colspan="' + parseInt(getEnablerQuestion.length + 2) + '">' + CategoryText + '</th></tr>';
                    html += '<tr><th name="0">SN</th>';
                    $.each(GetQuestion, function (i, value) {
                        if (CategoryId == value.controlCategory) {
                            html += '<th name=' + value.id + '>' + value.query + '</th>';
                        }
                    });
                    html += '<th name="0">Action  <input type="button" class="btn btn-info pull-right" value="+" onclick="AddMoreAnswers(this)"/></th></tr></thead><tbody>';
                    //for (var i = 0; i < getEnablerQuestion.length; i++) {
                    //    //  $.each(getEnablerQuestion, function (i, value) { //});
                    //    if (CategoryID == getEnablerQuestion[i].categoryId) {
                    //        if (GetQuestion.length > i) {
                    //            html += '<td><input type="text" class="form-control ques' + getEnablerQuestion[i].id + '"  value=' + getEnablerQuestion[i].answer + ' /></td>';
                    //        }
                    //    }
                    //}
                    // for (var w = 1; w <= getEnablerQuestion.length / GetQuestion.length; w++) {
                    var t = 1;
                    for (var w = 0; w <= getEnablerQuestion.length; w++) {
                        html += '<tr><td>' + (t) + '</td>';
                        t += 1;
                        var arr = [];
                        var MatchId = getEnablerQuestion[w].questionnaireId;
                        console.log(MatchId);
                        for (var i = 0; i < getEnablerQuestion.length; i++) {
                            if (getEnablerQuestion[i].questionnaireId == MatchId) {
                                arr.push(getEnablerQuestion[i]);
                            }
                        }
                        for (var s = 0; s < arr.length; s++) {
                            debugger;
                            //if (getEnablerQuestion[i].questionId == GetQuestion[s].id) {
                            html += '<td><input type="hidden" class="form-control ques" value="' + arr[s].questionId + '" /><input type="text" class="form-control ques' + arr[s].id + '"  value="' + arr[s].answer + '" /></td>';
                            //html += '<td>' + arr[s].answer + '</td>';
                            //getEnablerQuestion.splice(i, 1);
                            //}
                            // break;
                        }
                        html += '<td><input type="button" class="btn btn-danger" value="-" onclick="RemoveMoreAnswers(this)"></td></tr>';
                        res = jQuery.grep(getEnablerQuestion, function (a) {
                            debugger;
                            return a.questionnaireId !== getEnablerQuestion[w].questionnaireId;
                        });
                        console.log(res);
                        getEnablerQuestion = res;
                        w = 0;
                    }
                    html += '</tbody></table>';
                    $("#dvmultiTable").append(html);
                }
            });

            if ($("select[name=CategoryId]").val() == null) {
                $("#que").addClass("hidden");
            }
        });
    }
    function AddMoreAnswers(input) {
        debugger
        var tdLength = $(input).closest('tr').find('th').length;
        var sn = parseInt($(input).parent().parent().parent('thead').next('tbody').find("tr").length + 1);
        var html = '<tr><td>' + sn + '</td>';
        for (var i = 0; i < tdLength; i++) {
            if (i == 0 || i == tdLength - 1) { continue; }
            html += '<td>';
            html += $(input).parent().parent().parent('thead').next('tbody').find('tr:first td').eq(i).html();
            html += '</td>';
        }
        html += '<td><input type="button" class="btn btn-danger" value="-" onclick="RemoveMoreAnswers(this)"></td></tr>';
        //$("#visiblehide").html(html);
        //$("#visiblehide input").val('');
        //var x = $("#visiblehide").html();
        $(input).parent().parent().parent('thead').next('tbody').prepend(html);
    }
    function RemoveMoreAnswers(input) {
        $(input).closest('tr').remove();
    }
    function SaveQuestionnaire() {
        debugger;
        $('#preloader').show();
        var QuestionnaireXML = [];
        $('#dvmultiTable table').each(function (i, table) {
            var CategoryId = parseInt($(table).attr('id').split('_')[1]);
            var QuesArray = [], iQues = 0;
            var tablename = "#" + $(table).attr('id') + " tbody tr";
            debugger;


            var loop = $(table).find('thead tr:eq(1) th').length;

            $(tablename).each(function (k, tr) {
                debugger;
                var p = 0;
                var AnsArray = [];
                for (q = 2; q <= loop - 1; q++) {
                    var quesId = ($(tr).find("td:nth-child(" + q + ") input[type=hidden]")).val();//  parseInt($(th).attr('name'));
                    if (quesId == undefined) { return; }
                    AnsArray[p] = {
                        Answer: ($(tr).find("td:nth-child(" + q + ") input[type=text]")).val(),
                        QuestionId: quesId,
                        uniqueId: k + 1,
                    }
                    p++;
                }
                debugger;

                QuesArray[k] = {
                    uniqueId: k + 1,
                    AnsArray: AnsArray
                }

            });
            QuestionnaireXML[i] = {
                CategoryId: CategoryId,
                QuesArray: QuesArray
            }
        });
        var model = {
            Id: 0,
            ParentOrgId: parseInt($('#ParentOrgId').val()),
            ChildOrgId: parseInt($('#ChildOrgId').val() == '' ? 0 : $('#ChildOrgId').val()),
            QuestionnaireXML: JSON.stringify(QuestionnaireXML),
            CategoryId: 0
        }
        $("#Id").val(0);
        $("#ParentOrgId").val(parseInt($('#ParentOrgId').val()));
        $("#ChildOrgId").val(parseInt($('#ChildOrgId').val() == '' ? 0 : $('#ChildOrgId').val()));
        $("#QuestionnaireXML").val(JSON.stringify(QuestionnaireXML));
        $("#CategoryId").val(0);

    //    $.post('/ApplicationManagement/ClientEnabler/SubmitClientEnabler', { model: model }, function (res) {
    //        debugger;
    //        if (res.isSuccess) {
    //            //$('a[href="/ApplicationManagement/ClientEnabler/Index"]').click();
    //            $.get('/ApplicationManagement/ClientEnabler/Index', function (data) {
    //                $("#ajaxresult").html(data);
    //            });
    //        } else {
    //            toastr.error('Something went wrong!');
    //        }
    //        //$('#preloader').hide();
    //    });
    }
    //function SaveQuestionnaire() {
    //    debugger;
    //    $('#preloader').show();
    //    var QuestionnaireXML = [];
    //    $('#dvmultiTable table').each(function (i, table) {
    //        var CategoryId = parseInt($(table).attr('id').split('_')[1]);
    //        var QuesArray = [], iQues = 0;
    //        $(table).find('thead tr:eq(1) th').each(function (k, th) {
    //            var quesId = parseInt($(th).attr('name'));
    //            if (quesId == 0) { return; }
    //            var AnsArray = [];
    //            $('.ques' + quesId).each(function (i, input) {
    //                AnsArray[i] = {
    //                    Answer: $(input).val(),
    //                    Row: k
    //                }
    //            });
    //            QuesArray[iQues] = {
    //                QuestionId: quesId,
    //                AnsArray: AnsArray,

    //            }
    //            iQues++;
    //        });
    //        QuestionnaireXML[i] = {
    //            CategoryId: CategoryId,
    //            QuesArray: QuesArray
    //        }
    //    });
    //    var model = {
    //        ParentOrgId: parseInt($('#ParentOrgId').val()),
    //        ChildOrgId: parseInt($('#ChildOrgId').val()),
    //        QuestionnaireXML: JSON.stringify(QuestionnaireXML)
    //    }
    //    debugger;
    //    $.post('/ApplicationManagement/Assesment/SaveAssesment', { model: model }, function (res) {
    //        if (res.isSuccess) {
    //            $('a[href="/ApplicationManagement/Organogram/Index"]').click();
    //            toastr.success('Questionnaire saved successfully.');
    //        } else {
    //            toastr.error('Something went wrong!');
    //        }
    //        $('#preloader').hide();
    //    });
    //}
    function AddButton() {
        $(".titile_heading h1").html("Add Enabler");
        $(".service_line").addClass("active");
        $(".assign_panel").hide();
        //$(".titile_heading").show();}
    }
    function BackButton() {
        $(".titile_heading h1").html("Enabler");
        $(".service_line").removeClass("active");
        $(".assign_panel").show();
        //$(".titile_heading").show();
        //$("#viewbutton").show();
    }

    function fnBlockDelete(ThreatId, Action, Type) {
        $.getJSON('/Master/Threat/BlockDeleteThreat', { ThreatId: ThreatId, Type: Type }, function (data) {
            if (data > 0) {
                if (Type > 0) {
                    toastr.success(Action + " " + "successfully");
                } else {
                    toastr.success(Action + " " + "successfully");
                }
                setTimeout(function () { window.location.reload(); }, 2000);
            }
        });
    }
    $("input[type=submit]").click(function (event) {
        //if ($("select[name=TlevelId]").val() == 0) {
        //    event.preventDefault();
        //    toastr.error("Select threat level");
        //} else
        if ($("select[name=TTypeId]").val() == 0 && $("select[name=TTypeId]").val() == "") {
            event.preventDefault();
            toastr.error("Select threat type");
        } else if ($("input[name=ThreatName]").val() == "") {
            event.preventDefault();
            toastr.error("Threat name is required.");
        }
    });
    function Confirmation(id) {
        Swal.fire({
            title: 'Are you sure?',
            text: 'You want to delete this threat',
            showCancelButton: true,
            confirmButtonText: 'Delete',
        }).then((result) => {
            /* Read more about isConfirmed, isDenied below */
            if (result.isConfirmed) {
                $('#preloader').show();
                $.ajax({
                    url: "/Master/Threat/BlockDeleteThreat",
                    type: "POST",
                    cache: false,
                    data: { id: id, Type: Type = 1 },
                    success: function (result) {
                        $('#preloader').hide();
                        toastr.success("Delete successfully!!");
                        $('a[href="/Master/Threat/Index"]').click();
                    }, error: function (ex) {
                        console.log(ex.statusText);
                    }
                })
            }
        });
    }
</script>



